// 001 u_c_xxx
// 04 mar 00

(*$r+*)

unit u_c_generic_stack;
  interface

    type c_generic_stack<T>=
             class
               m_gen_array: Array of T;
               m_top_of_stack: Integer;

               constructor create_generic_stack(p_length: Integer);
               procedure push(p_gen: T);
               function f_pop: T;
             end; // c_generic_stack

         c_generic_stack=
             class
               constructor create_generic_stack(p_length: Integer);
             end; // c_generic_stack

         c_dictionary<Key, T>=
             Class
               m_c_stack: c_generic_stack<T>;
             End;

         c_generic_buffered_stack<T>=
             Class(c_generic_stack<T>)
             End;

  implementation
    uses SysUtils, u_display_simple;

    // -- c_generic_stack

    constructor c_generic_stack<T>.create_generic_stack(p_length: Integer);
      begin
        Inherited Create;
        SetLength(m_gen_array, p_length);
      end; // create_generic_stack

    procedure c_generic_stack<T>.push(p_gen: T);
      begin
        if m_top_of_stack= Length(m_gen_array)
          then SetLength(m_gen_array, 2* Length(m_gen_array));

        if m_top_of_stack< Length(m_gen_array)
          then begin
              m_gen_array[m_top_of_stack]:= p_gen;
              Inc(m_top_of_stack);
            end;
      end; // push

    function c_generic_stack<T>.f_pop: T;
      begin
        if m_top_of_stack>= 0
          then begin
              Dec(m_top_of_stack);
              Result:= m_gen_array[m_top_of_stack];
            end
          else raise Exception.Create('empty') ;
      end; // f_pop

    { c_generic_stack }

    constructor c_generic_stack.create_generic_stack(p_length: Integer);
      begin

      end;

end. // u_c_yyy


