// 001 u_00_xxx
// 25 nov 2010

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_some_generic;
  interface

    type c_some_generic <T> =
             class
                m_value: T;
                m_count: Integer;

                procedure non_generic;
                procedure set_T (p_T: T);
              end;

  implementation

    { c_some_generic<T> }

    procedure c_some_generic<T>.non_generic;
      begin
        Inc(m_count);
      end; // non_generic

    procedure c_some_generic<T>.set_T(p_T: T);
      begin
        m_value:= p_T;
      end; // set_T
end.
